
require("lib/managers/menu/MainMenuGui")

local init_original = MenuComponentManager.init

function MenuComponentManager:init()
	init_original(self)
	self._active_components.main_menu = {
		create = callback(self, self, "create_main_menu_gui"),
		close = callback(self, self, "close_main_menu_gui")
	}
end

function MenuComponentManager:create_main_menu_gui(node)
	self:_create_main_menu_gui(node)
end
function MenuComponentManager:_create_main_menu_gui(node)
	if not self._main_menu_gui then
		self._main_menu_gui = MainMenuGui:new(self._ws, self._fullscreen_ws, node)
	end
end
function MenuComponentManager:close_main_menu_gui()
	if self._main_menu_gui then
		self._main_menu_gui:close()
		self._main_menu_gui = nil
	end
end
function MenuComponentManager:set_new_main_menu_state(state, selected)
	if self._main_menu_gui then
		self._main_menu_gui:set_state(state, selected)
	end
end
function MenuComponentManager:enable_main_menu()
	if self._main_menu_gui then
		self._main_menu_gui:set_enabled(true)
	end
end
function MenuComponentManager:disable_main_menu()
	if self._main_menu_gui then
		self._main_menu_gui:set_enabled(false)
	end
end
function MenuComponentManager:set_main_menu_video(video)
	if self._main_menu_gui then
		self._main_menu_gui:set_video(video)
	end
end

Hooks:PostHook(MenuComponentManager, "update", "StartMenuBetaUpdate", function(self, t, dt)
     if self._main_menu_gui then
		self._main_menu_gui:update(t, dt)
	end
end)

Hooks:PostHook(MenuComponentManager, "input_focus", "StartMenuBetaUpdate_input_focus", function(self)
     if self._main_menu_gui then
		return self._main_menu_gui:input_focus()
	end
end)

Hooks:PostHook(MenuComponentManager, "scroll_up", "StartMenuBetaUpdate_scroll_up", function(self)
     if self._main_menu_gui and self._main_menu_gui:scroll_up() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "scroll_down", "StartMenuBetaUpdate_scroll_down", function(self)
     if self._main_menu_gui and self._main_menu_gui:scroll_down() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "move_up", "StartMenuBetaUpdate_move_up", function(self)
     if self._main_menu_gui and self._main_menu_gui:move_up() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "move_down", "StartMenuBetaUpdate_move_down", function(self)
     if self._main_menu_gui and self._main_menu_gui:move_down() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "move_left", "StartMenuBetaUpdate_move_left", function(self)
     if self._main_menu_gui and self._main_menu_gui:move_left() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "move_right", "StartMenuBetaUpdate_move_right", function(self)
     if self._main_menu_gui and self._main_menu_gui:move_right() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "input_focus", "StartMenuBetaUpdate_input_focus", function(self)
     if self._main_menu_gui then
		return self._main_menu_gui:input_focus()
	end
end)

Hooks:PostHook(MenuComponentManager, "next_page", "StartMenuBetaUpdate_next_page", function(self)
     if self._main_menu_gui and self._main_menu_gui:next_page() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "previous_page", "StartMenuBetaUpdate_previous_page", function(self)
     if self._main_menu_gui and self._main_menu_gui:previous_page() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "confirm_pressed", "StartMenuBetaUpdate_confirm_pressed", function(self)
     if self._main_menu_gui and self._main_menu_gui:confirm_pressed() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "back_pressed", "StartMenuBetaUpdate_back_pressed", function(self)
     if self._main_menu_gui and self._main_menu_gui:back_pressed() then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "special_btn_pressed", "StartMenuBetaUpdate_special_btn_pressed", function(self, ...)
     if self._main_menu_gui and self._main_menu_gui:special_btn_pressed(...) then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "mouse_pressed", "StartMenuBetaUpdate_mouse_pressed", function(self, o, button, x, y)
    if self._main_menu_gui and self._main_menu_gui:mouse_pressed(button, x, y) then
		return true
	end
end)

Hooks:PostHook(MenuComponentManager, "mouse_moved", "StartMenuBetaUpdate_mouse_moved", function(self, o, x, y)
     local wanted_pointer = "arrow"
	 
	 if self._main_menu_gui then
		local used, pointer = self._main_menu_gui:mouse_moved(o, x, y)
	if pointer or used then
		end
		return true, wanted_pointer
	end
end)